﻿// Copyright (c) Strange Loop Games. All rights reserved.
// See LICENSE file in the project root for full license information.
// <auto-generated />

namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Core.Items;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Modules;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    
    [Serialized]                
    [RequireComponent(typeof(PropertyAuthComponent))]                
    [RequireComponent(typeof(HousingComponent))]                  
    public partial class FloatingCandlesObject : 
        WorldObject,    
        IRepresentsItem
    {
        public override LocString DisplayName { get { return Localizer.DoStr("Floating Candles"); } } 


        public virtual Type RepresentedItemType { get { return typeof(FloatingCandlesItem); } } 


        protected override void Initialize()
        {
            this.GetComponent<HousingComponent>().Set(FloatingCandlesItem.HousingVal);                               
        }

        public override void Destroy()
        {
            base.Destroy();
        }
       
	   [Serialized] public bool CandlesOn = true;
	   
	   public override InteractResult OnActRight(InteractionContext context)
        {
			CandlesOn = !CandlesOn;
			return InteractResult.Success;
        }

        public override void Tick()
        {
            base.Tick();
            SetAnimatedState("Candles", CandlesOn);
        }
	   
	   
    }

    [Serialized]
    [LocDisplayName("Floating Candles")]
    [Ecopedia("Housing Objects", "Lights", createAsSubPage: true, display: InPageTooltip.DynamicTooltip)]                                                                           
    [Tag("Housing", 1)]
    public partial class FloatingCandlesItem :
        WorldObjectItem<FloatingCandlesObject> 
    {
        public override LocString DisplayDescription  { get { return Localizer.DoStr("A spooky set of candles."); } }

        static FloatingCandlesItem()
        {
            
        }

        [TooltipChildren] public HousingValue HousingTooltip { get { return HousingVal; } }
        [TooltipChildren] public static HousingValue HousingVal { get { return new HousingValue() 
                                                {
                                                    Category = "General",
                                                    Val = 1.8f,                                   
                                                    TypeForRoomLimit = "Lights", 
                                                    DiminishingReturnPercent = 0.2f    
        };}}
        

    }
 
    public partial class FloatingCandlesRecipe :
        RecipeFamily
    {
        public FloatingCandlesRecipe()
        {
            var product = new Recipe(
                "Floating Candles",
                Localizer.DoStr("Floating Candles"),
                new IngredientElement[]
				{
					new IngredientElement(typeof(TallowItem), 4),   
				},
					new CraftingElement[]
				{
					new CraftingElement<FloatingCandlesItem>(1),  
				}
            );
            this.Initialize(Localizer.DoStr("Floating Candles"), typeof(FloatingCandlesRecipe));
            this.Recipes = new List<Recipe> { product };
            this.LaborInCalories = CreateLaborInCaloriesValue(100, typeof(SmeltingSkill), typeof(FloatingCandlesRecipe), this.UILink()); 
            this.CraftMinutes = CreateCraftTimeValue(typeof(FloatingCandlesRecipe), this.UILink(), 4, typeof(SmeltingSkill), typeof(SmeltingFocusedSpeedTalent), typeof(SmeltingParallelSpeedTalent));     
            this.Initialize(Localizer.DoStr("Floating Candles"), typeof(FloatingCandlesRecipe));
            CraftingComponent.AddRecipe(typeof(WorkbenchObject), this);
        }
    }
}
